
package de.ivu.elect.business.ergebniskonflikt.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.ergebniskonflikt.entity.ErgebnisKonflikt;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractErgebnisKonfliktEdit {

  @Inject
  protected ErgebnisKonfliktDAO dao;

  @Inject
  protected ErgebnisKonfliktExtendedDAO extendedDao;

  public void delete(ErgebnisKonflikt entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(ErgebnisKonflikt entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(ErgebnisKonflikt entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected ErgebnisKonflikt getAttachedEntity(ErgebnisKonflikt entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected ErgebnisKonflikt getAttachedAndRefreshedEntity(ErgebnisKonflikt entity) {
    return dao.refresh(entity);
  }
}
